customer = new.tableRef("customer", "PostgreSQL", "postgre.config", "tpch")
orders = new.tableRef("orders", "PostgreSQL", "postgre.config", "tpch")
lineitem = new.tableRef("lineitem", "PostgreSQL", "postgre.config", "tpch")
supplier = new.tableRef("supplier", "PostgreSQL", "postgre.config", "tpch")
nation = new.tableRef("nation", "PostgreSQL", "postgre.config", "tpch")
q =
order(function(x) c(x$supp_nation, x$cust_nation, x$l_year), function(x) c(TRUE, TRUE, TRUE),
group(function(x) c(x$supp_nation, x$cust_nation, x$l_year),
select(function(x){
  y = new.env()
  y$supp_nation = x$n_name
  y$cust_nation = x$n_name
  y$l_year = format(x$l_shipdate, "%Y")
  y$volume = x$l_extendedprice * (1 - x$l_discount)
  y
},
join(from(nation),
join(from(nation),
join(from(customer),
join(from(orders),
join(from(supplier),
     from(lineitem),
     function(x, y)x$s_suppkey == y$l_suppkey),
     function(x, y)x$o_orderkey == y$l_orderkey),
     function(x, y)x$c_custkey == y$o_custkey),
     function(x, y)x$n_nationkey == y$s_nationkey),
     function(x, y)x$n_nationkey == y$c_nationkey && ((x$n_name == "FRANCE" && y$n_name == "GERMANY")
                  || (x$n_name == "GERMANY" && y$n_name == "FRANCE"))))))
print(query.force(q))
